#include <libgsloop_config.h>

#include <errno.h>

#include <gsloop_types.h>
#include <gsloop_client.h>
#include <gsloop_con.h>


int gsloop_client_cb(rn_pollevent_t	*rn_event)
{
	struct gsloop_client	*client = rn_event->client.data;
	struct gsloop_event	gsloop_event = {
		.fd		= rn_event->fd,
		.revents	= rn_event->revents,
	};
	int			err;

	err = client->event((gsloop_client_t *)client,
			    &gsloop_event,
			    client->event_data);

	return err;
}


int gsloop_client_close(gsloop_client_t	*gsloop_client_anon)
{
	struct gsloop_client	*client = (struct gsloop_client *)gsloop_client_anon;
	struct gsloop_server   	*server = client->server;
	int			err;

	if (!gsloop_client_anon)
		return -EINVAL;

	err = client->close((union gsloop_con *)client);
	if (err)
		return err;

	if (server->client_detach)
		err = server->client_detach(client);

	return err;
}


int gsloop_client_set_event_data(gsloop_client_t	*client_anon,
				 void			*event_data)
{
	struct gsloop_client	*client = (struct gsloop_client *)client_anon;

	if (!client_anon)
		return -EINVAL;

	client->event_data = event_data;

	return 0;
}


int gsloop_client_set_mask(gsloop_client_t	*client_anon,
			   short		events)
{
	struct gsloop_client	*client = (struct gsloop_client *)client_anon;
	struct gsloop   	*gsloop = client->gsloop;
	int			err;

	if (!client_anon)
		return -EINVAL;

	err = rn_setMask(&gsloop->rn, client->fd, events);
	if (err)
		return -err;	/* rn returns errno */
       
	return 0;
}


int gsloop_client_get_fd(gsloop_client_t	*client_anon)
{
	struct gsloop_client	*client = (struct gsloop_client *)client_anon;

	if (!client_anon)
		return -EINVAL;

	return client->fd;
}
